<?php
/**
*
* @author Username
* @package umil
* @copyright (c) 2008 phpBB Group
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
define('UMIL_AUTO', true);
define('IN_PHPBB', true);
$phpbb_root_path = (defined('PHPBB_ROOT_PATH')) ? PHPBB_ROOT_PATH : './';
$phpEx = substr(strrchr(__FILE__, '.'), 1);
include($phpbb_root_path . 'common.' . $phpEx);
$user->session_begin();
$auth->acl($user->data);
$user->setup();

if (!file_exists($phpbb_root_path . 'umil/umil_auto.' . $phpEx))
{
	trigger_error('Please download the latest UMIL (Unified MOD Install Library) from: <a href="http://www.phpbb.com/mods/umil/">phpBB.com/mods/umil</a>', E_USER_ERROR);
}

$mod_name = 'IMDB_MOD';

$version_config_name = 'imdb_version';

$language_file = 'mods/umil_imdb';

			$sql = 'SELECT MAX(bbcode_id) as max_bbcode_id
				FROM ' . BBCODES_TABLE;
			$result = $db->sql_query($sql);
			$row = $db->sql_fetchrow($result);
			$db->sql_freeresult($result);

			if ($row)
			{
				$bbcode_id = $row['max_bbcode_id'];

				// Make sure it is greater than the core bbcode ids...
				if ($bbcode_id <= NUM_CORE_BBCODES)
				{
					$bbcode_id = NUM_CORE_BBCODES;
				}
			}
			else
			{
				$bbcode_id = NUM_CORE_BBCODES;
			}

			$bbcode_match = '[imdb_credits]{TEXT}[/imdb_credits]';
			$bbcode_tpl = '<div id="imdb-credits">{TEXT}</div>';
			$data1 = build_regexp($bbcode_match, $bbcode_tpl);

			$bbcode_match = '[imdb_image]{TEXT}[/imdb_image]';
			$bbcode_tpl = '<img class="imdb-image" src="{TEXT}" alt="" />';
			$data2 = build_regexp($bbcode_match, $bbcode_tpl);

			$bbcode_match = '[imdb_stars]{NUMBER}[/imdb_stars]';
			$bbcode_tpl = '<div id="imdb_stars"><span style="width:{NUMBER}%" title="{NUMBER}%"></span></div>';
			$data3 = build_regexp($bbcode_match, $bbcode_tpl);

			$bbcode_match = '[imdb_title]{TEXT}[/imdb_title]';
			$bbcode_tpl = '<div class="imdb-title">{TEXT}</div>';
			$data4 = build_regexp($bbcode_match, $bbcode_tpl);

			$bbcode_match = '[imdb_wrap]{TEXT}[/imdb_wrap]';
			$bbcode_tpl = '<div id="imdb-wrap"><div id="imdb-content">{TEXT}</div></div>';
			$data5 = build_regexp($bbcode_match, $bbcode_tpl);

$versions = array(
	'0.0.1'	=> array(
		'table_row_insert'	=> array(
			array($table_prefix . 'bbcodes', array(
				array(
						'bbcode_id'					=> (int) $bbcode_id + 1,
						'bbcode_tag'				=> $data1['bbcode_tag'],
						'bbcode_match'				=> $data1['bbcode_match'],
						'bbcode_tpl'				=> $data1['bbcode_tpl'],
						'display_on_posting'		=> 0,
						'bbcode_helpline'			=> '',
						'first_pass_match'			=> $data1['first_pass_match'],
						'first_pass_replace'		=> $data1['first_pass_replace'],
						'second_pass_match'			=> $data1['second_pass_match'],
						'second_pass_replace'		=> $data1['second_pass_replace'],
				),
				array(
						'bbcode_id'					=> (int) $bbcode_id + 2,
						'bbcode_tag'				=> $data2['bbcode_tag'],
						'bbcode_match'				=> $data2['bbcode_match'],
						'bbcode_tpl'				=> $data2['bbcode_tpl'],
						'display_on_posting'		=> 0,
						'bbcode_helpline'			=> '',
						'first_pass_match'			=> $data2['first_pass_match'],
						'first_pass_replace'		=> $data2['first_pass_replace'],
						'second_pass_match'			=> $data2['second_pass_match'],
						'second_pass_replace'		=> $data2['second_pass_replace'],
				),
				array(
					'bbcode_id'						=> (int) $bbcode_id + 3,
						'bbcode_tag'				=> $data3['bbcode_tag'],
						'bbcode_match'				=> $data3['bbcode_match'],
						'bbcode_tpl'				=> $data3['bbcode_tpl'],
						'display_on_posting'		=> 0,
						'bbcode_helpline'			=> '',
						'first_pass_match'			=> $data3['first_pass_match'],
						'first_pass_replace'		=> $data3['first_pass_replace'],
						'second_pass_match'			=> $data3['second_pass_match'],
						'second_pass_replace'		=> $data3['second_pass_replace'],
				),
				array(
					'bbcode_id'						=> (int) $bbcode_id + 4,
						'bbcode_tag'				=> $data4['bbcode_tag'],
						'bbcode_match'				=> $data4['bbcode_match'],
						'bbcode_tpl'				=> $data4['bbcode_tpl'],
						'display_on_posting'		=> 0,
						'bbcode_helpline'			=> '',
						'first_pass_match'			=> $data4['first_pass_match'],
						'first_pass_replace'		=> $data4['first_pass_replace'],
						'second_pass_match'			=> $data4['second_pass_match'],
						'second_pass_replace'		=> $data4['second_pass_replace'],
				),
				array(
					'bbcode_id'						=> (int) $bbcode_id + 5,
						'bbcode_tag'				=> $data5['bbcode_tag'],
						'bbcode_match'				=> $data5['bbcode_match'],
						'bbcode_tpl'				=> $data5['bbcode_tpl'],
						'display_on_posting'		=> 0,
						'bbcode_helpline'			=> '',
						'first_pass_match'			=> $data5['first_pass_match'],
						'first_pass_replace'		=> $data5['first_pass_replace'],
						'second_pass_match'			=> $data5['second_pass_match'],
						'second_pass_replace'		=> $data5['second_pass_replace'],
				),
			)),
		),

		'custom'	=> 'umil_imdb',

		'cache_purge' => array(
			array(),
			array('template'),
			array('theme'),
		),

	),
);

include($phpbb_root_path . 'umil/umil_auto.' . $phpEx);

function umil_imdb($action, $version)
{
	global $db, $table_prefix, $umil, $cache;

	switch ($action)
	{
		case 'install' :
		$cache->destroy('sql', BBCODES_TABLE);
		break;

		case 'update' :
		break;


		case 'uninstall' :

		$umil->table_row_remove($table_prefix . 'bbcodes', array('bbcode_tag' => 'imdb_credits'));
		$umil->table_row_remove($table_prefix . 'bbcodes', array('bbcode_tag' => 'imdb_image'));
		$umil->table_row_remove($table_prefix . 'bbcodes', array('bbcode_tag' => 'imdb_stars'));
		$umil->table_row_remove($table_prefix . 'bbcodes', array('bbcode_tag' => 'imdb_title'));
		$umil->table_row_remove($table_prefix . 'bbcodes', array('bbcode_tag' => 'imdb_wrap'));

		$umil->cache_purge(array(
			array(),
			array('template'),
			array('theme'),
		));

		break;
	}
}

	/*
	* Build regular expression for custom bbcode
	*/
	function build_regexp(&$bbcode_match, &$bbcode_tpl)
	{
		$bbcode_match = trim($bbcode_match);
		$bbcode_tpl = trim($bbcode_tpl);
		$utf8 = strpos($bbcode_match, 'INTTEXT') !== false;

		// make sure we have utf8 support
		$utf8_pcre_properties = false;
		if (version_compare(PHP_VERSION, '5.1.0', '>=') || (version_compare(PHP_VERSION, '5.0.0-dev', '<=') && version_compare(PHP_VERSION, '4.4.0', '>=')))
		{
			// While this is the proper range of PHP versions, PHP may not be linked with the bundled PCRE lib and instead with an older version
			if (@preg_match('/\p{L}/u', 'a') !== false)
			{
				$utf8_pcre_properties = true;
			}
		}

		$fp_match = preg_quote($bbcode_match, '!');
		$fp_replace = preg_replace('#^\[(.*?)\]#', '[$1:$uid]', $bbcode_match);
		$fp_replace = preg_replace('#\[/(.*?)\]$#', '[/$1:$uid]', $fp_replace);

		$sp_match = preg_quote($bbcode_match, '!');
		$sp_match = preg_replace('#^\\\\\[(.*?)\\\\\]#', '\[$1:$uid\]', $sp_match);
		$sp_match = preg_replace('#\\\\\[/(.*?)\\\\\]$#', '\[/$1:$uid\]', $sp_match);
		$sp_replace = $bbcode_tpl;

		// @todo Make sure to change this too if something changed in message parsing
		$tokens = array(
			'URL'	 => array(
				'!(?:(' . str_replace(array('!', '\#'), array('\!', '#'), get_preg_expression('url')) . ')|(' . str_replace(array('!', '\#'), array('\!', '#'), get_preg_expression('www_url')) . '))!ie'	=>	"\$this->bbcode_specialchars(('\$1') ? '\$1' : 'http://\$2')"
			),
			'LOCAL_URL'	 => array(
				'!(' . str_replace(array('!', '\#'), array('\!', '#'), get_preg_expression('relative_url')) . ')!e'	=>	"\$this->bbcode_specialchars('$1')"
			),
			'EMAIL' => array(
				'!(' . get_preg_expression('email') . ')!ie'	=>	"\$this->bbcode_specialchars('$1')"
			),
			'TEXT' => array(
				'!(.*?)!es'	 =>	"str_replace(array(\"\\r\\n\", '\\\"', '\\'', '(', ')'), array(\"\\n\", '\"', '&#39;', '&#40;', '&#41;'), trim('\$1'))"
			),
			'SIMPLETEXT' => array(
				'!([a-zA-Z0-9-+.,_ ]+)!'	 =>	"$1"
			),
			'INTTEXT' => array(
				($utf8_pcre_properties) ? '!([\p{L}\p{N}\-+,_. ]+)!u' : '!([a-zA-Z0-9\-+,_. ]+)!u'	 =>	"$1"
			),
			'IDENTIFIER' => array(
				'!([a-zA-Z0-9-_]+)!'	 =>	"$1"
			),
			'COLOR' => array(
				'!([a-z]+|#[0-9abcdef]+)!i'	=>	'$1'
			),
			'NUMBER' => array(
				'!([0-9]+)!'	=>	'$1'
			)
		);

		$sp_tokens = array(
			'URL'	 => '(?i)((?:' . str_replace(array('!', '\#'), array('\!', '#'), get_preg_expression('url')) . ')|(?:' . str_replace(array('!', '\#'), array('\!', '#'), get_preg_expression('www_url')) . '))(?-i)',
			'LOCAL_URL'	 => '(?i)(' . str_replace(array('!', '\#'), array('\!', '#'), get_preg_expression('relative_url')) . ')(?-i)',
			'EMAIL' => '(' . get_preg_expression('email') . ')',
			'TEXT' => '(.*?)',
			'SIMPLETEXT' => '([a-zA-Z0-9-+.,_ ]+)',
			'INTTEXT' => ($utf8_pcre_properties) ? '([\p{L}\p{N}\-+,_. ]+)' : '([a-zA-Z0-9\-+,_. ]+)',
			'IDENTIFIER' => '([a-zA-Z0-9-_]+)',
			'COLOR' => '([a-zA-Z]+|#[0-9abcdefABCDEF]+)',
			'NUMBER' => '([0-9]+)',
		);

		$pad = 0;
		$modifiers = 'i';
		$modifiers .= ($utf8 && $utf8_pcre_properties) ? 'u' : '';

		if (preg_match_all('/\{(' . implode('|', array_keys($tokens)) . ')[0-9]*\}/i', $bbcode_match, $m))
		{
			foreach ($m[0] as $n => $token)
			{
				$token_type = $m[1][$n];

				reset($tokens[strtoupper($token_type)]);
				list($match, $replace) = each($tokens[strtoupper($token_type)]);

				// Pad backreference numbers from tokens
				if (preg_match_all('/(?<!\\\\)\$([0-9]+)/', $replace, $repad))
				{
					$repad = $pad + sizeof(array_unique($repad[0]));
					$replace = preg_replace('/(?<!\\\\)\$([0-9]+)/e', "'\${' . (\$1 + \$pad) . '}'", $replace);
					$pad = $repad;
				}

				// Obtain pattern modifiers to use and alter the regex accordingly
				$regex = preg_replace('/!(.*)!([a-z]*)/', '$1', $match);
				$regex_modifiers = preg_replace('/!(.*)!([a-z]*)/', '$2', $match);

				for ($i = 0, $size = strlen($regex_modifiers); $i < $size; ++$i)
				{
					if (strpos($modifiers, $regex_modifiers[$i]) === false)
					{
						$modifiers .= $regex_modifiers[$i];

						if ($regex_modifiers[$i] == 'e')
						{
							$fp_replace = "'" . str_replace("'", "\\'", $fp_replace) . "'";
						}
					}

					if ($regex_modifiers[$i] == 'e')
					{
						$replace = "'.$replace.'";
					}
				}

				$fp_match = str_replace(preg_quote($token, '!'), $regex, $fp_match);
				$fp_replace = str_replace($token, $replace, $fp_replace);

				$sp_match = str_replace(preg_quote($token, '!'), $sp_tokens[$token_type], $sp_match);
				$sp_replace = str_replace($token, '${' . ($n + 1) . '}', $sp_replace);
			}

			$fp_match = '!' . $fp_match . '!' . $modifiers;
			$sp_match = '!' . $sp_match . '!s' . (($utf8) ? 'u' : '');

			if (strpos($fp_match, 'e') !== false)
			{
				$fp_replace = str_replace("'.'", '', $fp_replace);
				$fp_replace = str_replace(".''.", '.', $fp_replace);
			}
		}
		else
		{
			// No replacement is present, no need for a second-pass pattern replacement
			// A simple str_replace will suffice
			$fp_match = '!' . $fp_match . '!' . $modifiers;
			$sp_match = $fp_replace;
			$sp_replace = '';
		}

		// Lowercase tags
		$bbcode_tag = preg_replace('/.*?\[([a-z0-9_-]+=?).*/i', '$1', $bbcode_match);
		$bbcode_search = preg_replace('/.*?\[([a-z0-9_-]+)=?.*/i', '$1', $bbcode_match);

		if (!preg_match('/^[a-zA-Z0-9_-]+=?$/', $bbcode_tag))
		{
			global $user;
			trigger_error($user->lang['BBCODE_INVALID'] . adm_back_link($this->u_action), E_USER_WARNING);
		}

		$fp_match = preg_replace('#\[/?' . $bbcode_search . '#ie', "strtolower('\$0')", $fp_match);
		$fp_replace = preg_replace('#\[/?' . $bbcode_search . '#ie', "strtolower('\$0')", $fp_replace);
		$sp_match = preg_replace('#\[/?' . $bbcode_search . '#ie', "strtolower('\$0')", $sp_match);
		$sp_replace = preg_replace('#\[/?' . $bbcode_search . '#ie', "strtolower('\$0')", $sp_replace);

		return array(
			'bbcode_match'				=> $bbcode_match,
			'bbcode_tpl'				=> $bbcode_tpl,
			'bbcode_tag'				=> $bbcode_tag,
			'first_pass_match'			=> $fp_match,
			'first_pass_replace'		=> $fp_replace,
			'second_pass_match'			=> $sp_match,
			'second_pass_replace'		=> $sp_replace
		);
	}

?>